%ROBOT: dati la lunghezza L_arm1 e la lunghezza L_arm2(gomito-mano) di un 
%       braccio robot, e specificati interattivamente 
%       (vedere la funzione "disegna") una serie di punti che indicano
%       la posizione della mano del braccio robot a vari istanti successivi
%       calcola e mostra la traiettoria del braccio
function Robot_completo(L_arm1,L_arm2)
%-la spalla  montata nell'origine.
%-determinazione del cerchio massimo raggiungibile dal braccio
limit=L_arm1+L_arm2;
axis([-limit limit -limit limit]);
hold on;
circ_x=linspace(-limit,limit,50);
circ_y=sqrt(limit^2-circ_x.^2);
%-plot degli assi e del cerchio limite
plot(circ_x,zeros(50),'c');
plot(zeros(50),circ_x,'c');
plot(circ_x,circ_y,'c');
plot(circ_x,-circ_y,'c');
%-se i due segmenti del braccio hanno lunghezze
% differenti, c' anche un'altra regione circolare, 
% attorno alla spalla, che il braccio non pu raggiungere
%-determinazione del cerchio minimo raggiungibile dal
% braccio, e suo plot
limit2=abs(L_arm1-L_arm2);
circ2_x=linspace(-limit2,limit2,30);
circ2_y=sqrt(limit2^2-circ2_x.^2);
plot(circ2_x,circ2_y,'c');
plot(circ2_x,-circ2_y,'c');
%-inserimento dei punti di passaggio
pos=disegna;
numpti=size(pos,2);
%-per ogni punto di passaggio:
for i=1:numpti
% 1)viene rilevato se esso si trova in un'area non raggiun-
%   gibile dal braccio, in questo caso il programma termina
%   (inoltre la posizione "incriminata" viene contrassegnata
%   con una 'x' blu)
    if((norm(pos(:,i))>limit)|(norm(pos(:,i))<limit2))
        plot(pos(1,i),pos(2,i),'bx');
        disp ('goal unreachable');
        return;
    end
% 2)se  ammissibile, viene calcolata la coppia di angoli
%   asse_x<->spalla-gomito e spalla-gomito<->gomito-mano
%   che portano il braccio ad avere la mano nel punto dato   
    [tetaA(i),tetaB(i)]=teta(pos(:,i),L_arm1,L_arm2);
    
end;  
%-i motori imprimono movimenti angolari ai due segmenti
% del braccio, cerchiamo una sequenza di coppie di angoli
% interpolando con poly a tratti C2 un set di coppie di angoli univocamente
% determinati dai punti di passaggio
t=linspace(0,1,numpti);
tt=linspace(0,1,50);
teta1=spline(t,tetaA,tt);
teta2=spline(t,tetaB,tt);
%-determinazione, per ogni coppia di angoli, delle posizioni
% del gomito e della mano
dim=size(teta1,2)
for i=1:dim
 x_elbow(i)=L_arm1*cos(teta1(i));
 y_elbow(i)=L_arm1*sin(teta1(i));
 x_hand(i)=x_elbow(i)+L_arm2*cos(teta1(i)+teta2(i));
 y_hand(i)=y_elbow(i)+L_arm2*sin(teta1(i)+teta2(i));
end;
%-plot successivi per simulare il movimento
visual_step=5;
for i=1:dim 
    clf;
    if ((mod((i-1),visual_step)==0)|(i==dim))
        axis([-limit limit -limit limit]);
        hold on;
        plot(circ_x,zeros(50),'c');
        plot(zeros(50),circ_x,'c');
        plot(pos(1,:),pos(2,:),'r.');
        plot(x_hand(1),y_hand(1),'rs'); 
        plot(x_hand(dim),y_hand(dim),'rs');
        plot(circ_x,circ_y,'c');
        plot(circ_x,-circ_y,'c');
        plot(circ2_x,circ2_y,'c');
        plot(circ2_x,-circ2_y,'c');
        plot(x_hand,y_hand,'g:');        
        plot(0,0,'ko');
        plot(x_elbow(i),y_elbow(i),'ko');
        plot([0 x_elbow(i)],[0 y_elbow(i)],'k');
        plot([x_elbow(i) x_hand(i)],[y_elbow(i) y_hand(i)],'k');
        plot(x_hand(i),y_hand(i),'ko');
        pause(0.1);   
    end
end
